<?php
// $Id: cck_field_rename.module,v 1.0 2010/09/12 02:01:00 thenicespider Exp $

/**
 * @file
 * Administration process forms of cck_field_rename module.
 */
 
/**
 * Menu callback;
 */
 
function cck_field_rename_action() {
global $_cck_fields;

  $form = array();
  
  // Generate the form
  $form['cck_field_rename_action'] = array(
    '#type' => 'fieldset',
    '#weight' => -30,
    '#title' => t('Rename a CCK field'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#description' => t('<strong>Please make a DATABASE BACKUP first and make sure your backup is not corrupt!</strong>')    
  );
  
  $sql = " SELECT field_name FROM {content_node_field} ORDER BY field_name";
  $results = db_query($sql);
  
  while ($data = db_fetch_object($results)) {
    $_cck_fields[$data->field_name]= $data->field_name;  
  }
  
  $form['cck_field_rename_action']['cck_field_rename_source'] = array(
    '#type' => 'select',
    '#title' => t('Select CCK field'),
    '#options' => $_cck_fields,
    '#default_value' => variable_get('cck_field_rename_source', ''),
  );    
  
  $form['cck_field_rename_action']['cck_field_rename_target'] = array(
    '#type' => 'textfield',
    '#title' => t('New field name'),
    '#default_value' => variable_get('cck_field_rename_target', ''),
    '#description' => t('After rename field you must run <a href="' . base_path() . 'admin/settings/performance">"Clear cached data"</a>'),
    '#maxlength' => 32
  ); 
  
  $form['cck_field_rename_action']['cck_field_rename_process'] = array(
      '#type' => 'submit',
      '#value' => t('Rename field'),
      '#submit' => array('cck_field_rename_process'),
    );
  return $form;
  //return system_settings_form($form);
}

//Rename the selected field
function cck_field_rename_process() {
global $_cck_fields;
  $field_source = addslashes(strip_tags($_REQUEST['cck_field_rename_source']));
  $field_target = addslashes(strip_tags($_REQUEST['cck_field_rename_target']));
  
  //Check if target same as existing-source
  if (in_array($field_target, $_cck_fields)) {
    drupal_set_message(t("Field name '$field_target' already in use."));
    return;  
  }
  
  //print $field_source.'<br />';
  //print $field_target;
  //return;
   
  //get content type
  $sql = " SELECT type_name FROM {content_node_field_instance} WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
  $cck_content_type = $data->type_name;
  
  //get field type
  $sql = " SELECT type FROM {content_node_field} WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
  $cck_field_type = $data->type;
  
  //check supported type
  $supported_field_type = array('text', 'number_integer', 'number_float', 'number_decimal',
    'filefield', 'nodereference', 'date', 'computed', 'datetime', 'datestamp', 'link',
    'content_taxonomy');
  if (!in_array($cck_field_type, $supported_field_type)) {
    drupal_set_message(t("Sorry, field type not yet supported (please report this issue): $cck_field_type."));
    return;
  }
  
  if (substr($field_target, 0, 6) != 'field_') {
    drupal_set_message(t("Sorry, new field name must starting with 'field_' (i.e: field_myfield)."));
    return;  
  }
  
  //if multigroup
  $sql = " SELECT group_type FROM {content_group_fields} cgf "
        ." INNER JOIN {content_group} cg ON cg.type_name= cgf.type_name AND cg.group_name=cgf.group_name"
        ." WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
  $group_type = $data->group_type;
  
  //field
  $table_name       = 'content_type_'. $cck_content_type;
  
  if ($group_type == 'multigroup') {
     $table_name = 'content_'. $field_source;
  }
  
  $field = content_fields($field_source);
  $field_info = content_database_info($field);

  $field_type = $field_info['columns']['value']['type'];
  $field_size = $field_info['columns']['value']['size'];
  $field_prec = $field_info['columns']['value']['precision'];
  $field_scal = $field_info['columns']['value']['scale'];
  $field_leng = $field_info['columns']['value']['length'];
  
  //print_r($field_info['columns']['value']); 
  //return;
  
  switch ($cck_field_type) {
    case 'text':
      if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target .'_value', 
          array('type' => $field_type, 'size' => $field_size, 'not null' => FALSE));  
      }
      if (db_column_exists($table_name, $field_source .'_format')) {
        db_change_field($ret, $table_name, $field_source . '_format', $field_target . '_format', 
          array('type' => 'int', 'size' => 'normal', 'not null' => FALSE));  
      }
      break;
      
    case 'number_integer':
      if (db_column_exists($table_name, $field_source .'_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => 'normal', 'not null' => FALSE));
      }
      break;
      
    case 'number_float':
      if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => 'normal', 'not null' => FALSE));
      }
      break;
      
    case 'number_decimal':
      if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source  . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => 'normal', 
          'precision' => $field_prec, 'scale' => $field_scal ));
      }
      break;
      
    case 'filefield':
      if (db_column_exists($table_name, $field_source . '_fid')) {
        db_change_field($ret, $table_name, $field_source . '_fid', $field_target . '_fid', 
          array('type' => 'int', 'size' => 'normal', 'not null' => FALSE));      
        db_change_field($ret, $table_name, $field_source . '_list', $field_target . '_list', 
          array('type' => 'int', 'size' => 'tiny', 'not null' => FALSE));      
        db_change_field($ret, $table_name, $field_source . '_data', $field_target . '_data', 
          array('type' => 'text', 'size' => 'normal', 'not null' => FALSE));
      }
      break;
      
    case 'nodereference':
      if (db_column_exists($table_name, $field_source . '_nid')) {
        db_change_field($ret, $table_name, $field_source . '_nid', $field_target . '_nid', 
          array('type' => 'int', 'size' => 'normal', 'not null' => FALSE));
      }
      break;
    
    case 'date':
    case 'datetime':
    case 'datestamp':
      if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => 'normal', 'not null' => FALSE, 'length' => $field_leng));
      }
      break;
    case 'computed':
     if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => $field_size, 'not null' => FALSE));  
      }
      break;  
    case 'link':
      if (db_column_exists($table_name, $field_source . '_url')) {
        db_change_field($ret, $table_name, $field_source  .'_url', $field_target .'_url', 
          array('type' => 'text', 'size' => 'normal', 'not null' => FALSE));
      }
      if (db_column_exists($table_name, $field_source .'_title')) {      
        db_change_field($ret, $table_name, $field_source .'_title', $field_target .'_title', 
          array('type' => 'text', 'size' => 'normal', 'not null' => FALSE));
      }
      if (db_column_exists($table_name, $field_source . '_attributes')) {      
        db_change_field($ret, $table_name, $field_source .'_attributes', $field_target .'_attributes',
          array('type' => 'text', 'size' => 'normal', 'not null' => FALSE));
      }
      break;
    case 'content_taxonomy':
      if (db_column_exists($table_name, $field_source . '_value')) {
        db_change_field($ret, $table_name, $field_source . '_value', $field_target . '_value', 
          array('type' => $field_type, 'size' => 'normal', 'not null' => FALSE));
      }
      break;
  }
  
  if ($group_type == 'multigroup') {
    db_rename_table($ret, 'content_' . $field_source, 'content_' . $field_target);
  }
  
  //content_node_field_instance
  $sql = " UPDATE {content_node_field_instance} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  //content_group_fields
  $sql = " UPDATE {content_group_fields} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  //content_node_field
  $sql = " UPDATE {content_node_field} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  db_query("TRUNCATE TABLE {cache_content}");
  //drupal_flush_all_caches(); //must run from UI otherwise still error on manage field?
  
  //Results
  drupal_set_message(t(
    " Content type: $cck_content_type, field type: $cck_field_type<br />"
   ." Rename '$field_source' to '$field_target' successful."));
  
  return;
}
